%Ekta Gujral, Georgios Theocharous and Vagelis Papalexakis - University of
%California,Riverside,CA.Computer Science (2019-2020)
% "SPADE:Streaming PARAFAC2 DEcompistion for Sparse Datasets",
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT:
% X: Tensor or sptensor. [I x J x K]
% ratio: initial batch ratio [0-0.5]
% OUTPUT
% Xold: Initial tensor data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Xold,dimsX,initialBatch,streamingBatch,idx]=getDataforStreaming(X,ratio)
    J=size(X{1},2);K=size(X,2);
    dimsX = [[], J, K]; 
    initialBatch = round(ratio*dimsX(end));
    streamingBatch = dimsX(end)-initialBatch;

    idx = repmat({':'}, 1, length(dimsX));
    idx(end) = {1:initialBatch};
    Xold = X(idx{:});

end